package net.vtstar.zhongtong.avi.gateway.assembly.job;

import lombok.extern.slf4j.Slf4j;
import net.vtstar.scada.base.equipmgt.domain.Enum.EquipStatusEnum;
import net.vtstar.scada.base.gather.domain.EquipmentData;
import net.vtstar.scada.base.gather.job.GatherJob;
import net.vtstar.zhongtong.avi.gateway.assembly.domain.FocusBoosterOilMachine;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.stereotype.Component;

/**
 * 助力油加注设备数据采集JOB
 */
@Slf4j
@Component
public class FocusBoosterOilMachineJob extends GatherJob {

    private static final String NAME = "FOCUS_BOOSTER_OIL";

    @Override
    protected void executeInternal(JobExecutionContext context) throws JobExecutionException {

        log.info("JobName: {}", context.getJobDetail().getKey().getName());
        super.gatherByModbus(NAME, FocusBoosterOilMachine.class);
    }

    protected boolean handleObject(EquipmentData equipmentData) {
        FocusBoosterOilMachine data = (FocusBoosterOilMachine) equipmentData;
        Integer state = data.getState();
        if (state == null) {
            return false;
        }
        switch (state) {
            case 0:
                equipmentData.setEquipStatus(EquipStatusEnum.SHUTDOWN);
                break;
            case 1:
                equipmentData.setEquipStatus(EquipStatusEnum.RUN);
                break;
            case 2:
                equipmentData.setEquipStatus(EquipStatusEnum.ALARM);
                break;
            default:
                return false;
        }
        return true;
    }

    @Override
    protected Object handleValue(String fieldName, Object value) {
        return value;
    }
}
